// Code generated by github.com/Khan/genqlient, DO NOT EDIT.

package pkg

import (
	"context"

	"github.com/Khan/genqlient/graphql"
)

// GetNotesProject includes the requested fields of the GraphQL type Project.
type GetNotesProject struct {
	// ID of the project.
	Id string `json:"id"`
	// A single merge request of the project.
	MergeRequest GetNotesProjectMergeRequest `json:"mergeRequest"`
}

// GetId returns GetNotesProject.Id, and is useful for accessing the field via an interface.
func (v *GetNotesProject) GetId() string { return v.Id }

// GetMergeRequest returns GetNotesProject.MergeRequest, and is useful for accessing the field via an interface.
func (v *GetNotesProject) GetMergeRequest() GetNotesProjectMergeRequest { return v.MergeRequest }

// GetNotesProjectMergeRequest includes the requested fields of the GraphQL type MergeRequest.
type GetNotesProjectMergeRequest struct {
	// Indicates if the merge request is a draft.
	Draft bool `json:"draft"`
	// Title of the merge request.
	Title string `json:"title"`
	// Description of the merge request (Markdown rendered as HTML for caching).
	Description string `json:"description"`
	// State of the merge request.
	State MergeRequestState `json:"state"`
	// Target branch of the merge request.
	TargetBranch string `json:"targetBranch"`
	// Assignees of the merge request.
	Assignees GetNotesProjectMergeRequestAssigneesMergeRequestAssigneeConnection `json:"assignees"`
	// Labels of the merge request.
	Labels GetNotesProjectMergeRequestLabelsLabelConnection `json:"labels"`
	// Users who approved the merge request.
	ApprovedBy GetNotesProjectMergeRequestApprovedByUserCoreConnection `json:"approvedBy"`
	// User who created this merge request.
	Author GetNotesProjectMergeRequestAuthor `json:"author"`
	// All notes on this noteable.
	Notes GetNotesProjectMergeRequestNotesNoteConnection `json:"notes"`
}

// GetDraft returns GetNotesProjectMergeRequest.Draft, and is useful for accessing the field via an interface.
func (v *GetNotesProjectMergeRequest) GetDraft() bool { return v.Draft }

// GetTitle returns GetNotesProjectMergeRequest.Title, and is useful for accessing the field via an interface.
func (v *GetNotesProjectMergeRequest) GetTitle() string { return v.Title }

// GetDescription returns GetNotesProjectMergeRequest.Description, and is useful for accessing the field via an interface.
func (v *GetNotesProjectMergeRequest) GetDescription() string { return v.Description }

// GetState returns GetNotesProjectMergeRequest.State, and is useful for accessing the field via an interface.
func (v *GetNotesProjectMergeRequest) GetState() MergeRequestState { return v.State }

// GetTargetBranch returns GetNotesProjectMergeRequest.TargetBranch, and is useful for accessing the field via an interface.
func (v *GetNotesProjectMergeRequest) GetTargetBranch() string { return v.TargetBranch }

// GetAssignees returns GetNotesProjectMergeRequest.Assignees, and is useful for accessing the field via an interface.
func (v *GetNotesProjectMergeRequest) GetAssignees() GetNotesProjectMergeRequestAssigneesMergeRequestAssigneeConnection {
	return v.Assignees
}

// GetLabels returns GetNotesProjectMergeRequest.Labels, and is useful for accessing the field via an interface.
func (v *GetNotesProjectMergeRequest) GetLabels() GetNotesProjectMergeRequestLabelsLabelConnection {
	return v.Labels
}

// GetApprovedBy returns GetNotesProjectMergeRequest.ApprovedBy, and is useful for accessing the field via an interface.
func (v *GetNotesProjectMergeRequest) GetApprovedBy() GetNotesProjectMergeRequestApprovedByUserCoreConnection {
	return v.ApprovedBy
}

// GetAuthor returns GetNotesProjectMergeRequest.Author, and is useful for accessing the field via an interface.
func (v *GetNotesProjectMergeRequest) GetAuthor() GetNotesProjectMergeRequestAuthor { return v.Author }

// GetNotes returns GetNotesProjectMergeRequest.Notes, and is useful for accessing the field via an interface.
func (v *GetNotesProjectMergeRequest) GetNotes() GetNotesProjectMergeRequestNotesNoteConnection {
	return v.Notes
}

// GetNotesProjectMergeRequestApprovedByUserCoreConnection includes the requested fields of the GraphQL type UserCoreConnection.
// The GraphQL type's documentation follows.
//
// The connection type for UserCore.
type GetNotesProjectMergeRequestApprovedByUserCoreConnection struct {
	// A list of nodes.
	Nodes []GetNotesProjectMergeRequestApprovedByUserCoreConnectionNodesUserCore `json:"nodes"`
}

// GetNodes returns GetNotesProjectMergeRequestApprovedByUserCoreConnection.Nodes, and is useful for accessing the field via an interface.
func (v *GetNotesProjectMergeRequestApprovedByUserCoreConnection) GetNodes() []GetNotesProjectMergeRequestApprovedByUserCoreConnectionNodesUserCore {
	return v.Nodes
}

// GetNotesProjectMergeRequestApprovedByUserCoreConnectionNodesUserCore includes the requested fields of the GraphQL type UserCore.
// The GraphQL type's documentation follows.
//
// Core represention of a GitLab user.
type GetNotesProjectMergeRequestApprovedByUserCoreConnectionNodesUserCore struct {
	// Username of the user. Unique within this instance of GitLab.
	Username string `json:"username"`
}

// GetUsername returns GetNotesProjectMergeRequestApprovedByUserCoreConnectionNodesUserCore.Username, and is useful for accessing the field via an interface.
func (v *GetNotesProjectMergeRequestApprovedByUserCoreConnectionNodesUserCore) GetUsername() string {
	return v.Username
}

// GetNotesProjectMergeRequestAssigneesMergeRequestAssigneeConnection includes the requested fields of the GraphQL type MergeRequestAssigneeConnection.
// The GraphQL type's documentation follows.
//
// The connection type for MergeRequestAssignee.
type GetNotesProjectMergeRequestAssigneesMergeRequestAssigneeConnection struct {
	// A list of nodes.
	Nodes []GetNotesProjectMergeRequestAssigneesMergeRequestAssigneeConnectionNodesMergeRequestAssignee `json:"nodes"`
}

// GetNodes returns GetNotesProjectMergeRequestAssigneesMergeRequestAssigneeConnection.Nodes, and is useful for accessing the field via an interface.
func (v *GetNotesProjectMergeRequestAssigneesMergeRequestAssigneeConnection) GetNodes() []GetNotesProjectMergeRequestAssigneesMergeRequestAssigneeConnectionNodesMergeRequestAssignee {
	return v.Nodes
}

// GetNotesProjectMergeRequestAssigneesMergeRequestAssigneeConnectionNodesMergeRequestAssignee includes the requested fields of the GraphQL type MergeRequestAssignee.
// The GraphQL type's documentation follows.
//
// A user assigned to a merge request.
type GetNotesProjectMergeRequestAssigneesMergeRequestAssigneeConnectionNodesMergeRequestAssignee struct {
	// ID of the user.
	Id string `json:"id"`
	// Username of the user. Unique within this instance of GitLab.
	Username string `json:"username"`
}

// GetId returns GetNotesProjectMergeRequestAssigneesMergeRequestAssigneeConnectionNodesMergeRequestAssignee.Id, and is useful for accessing the field via an interface.
func (v *GetNotesProjectMergeRequestAssigneesMergeRequestAssigneeConnectionNodesMergeRequestAssignee) GetId() string {
	return v.Id
}

// GetUsername returns GetNotesProjectMergeRequestAssigneesMergeRequestAssigneeConnectionNodesMergeRequestAssignee.Username, and is useful for accessing the field via an interface.
func (v *GetNotesProjectMergeRequestAssigneesMergeRequestAssigneeConnectionNodesMergeRequestAssignee) GetUsername() string {
	return v.Username
}

// GetNotesProjectMergeRequestAuthor includes the requested fields of the GraphQL type MergeRequestAuthor.
// The GraphQL type's documentation follows.
//
// The author of the merge request.
type GetNotesProjectMergeRequestAuthor struct {
	// Username of the user. Unique within this instance of GitLab.
	Username string `json:"username"`
}

// GetUsername returns GetNotesProjectMergeRequestAuthor.Username, and is useful for accessing the field via an interface.
func (v *GetNotesProjectMergeRequestAuthor) GetUsername() string { return v.Username }

// GetNotesProjectMergeRequestLabelsLabelConnection includes the requested fields of the GraphQL type LabelConnection.
// The GraphQL type's documentation follows.
//
// The connection type for Label.
type GetNotesProjectMergeRequestLabelsLabelConnection struct {
	// A list of nodes.
	Nodes []GetNotesProjectMergeRequestLabelsLabelConnectionNodesLabel `json:"nodes"`
}

// GetNodes returns GetNotesProjectMergeRequestLabelsLabelConnection.Nodes, and is useful for accessing the field via an interface.
func (v *GetNotesProjectMergeRequestLabelsLabelConnection) GetNodes() []GetNotesProjectMergeRequestLabelsLabelConnectionNodesLabel {
	return v.Nodes
}

// GetNotesProjectMergeRequestLabelsLabelConnectionNodesLabel includes the requested fields of the GraphQL type Label.
type GetNotesProjectMergeRequestLabelsLabelConnectionNodesLabel struct {
	// Content of the label.
	Title string `json:"title"`
}

// GetTitle returns GetNotesProjectMergeRequestLabelsLabelConnectionNodesLabel.Title, and is useful for accessing the field via an interface.
func (v *GetNotesProjectMergeRequestLabelsLabelConnectionNodesLabel) GetTitle() string {
	return v.Title
}

// GetNotesProjectMergeRequestNotesNoteConnection includes the requested fields of the GraphQL type NoteConnection.
// The GraphQL type's documentation follows.
//
// The connection type for Note.
type GetNotesProjectMergeRequestNotesNoteConnection struct {
	// A list of nodes.
	Nodes []GetNotesProjectMergeRequestNotesNoteConnectionNodesNote `json:"nodes"`
}

// GetNodes returns GetNotesProjectMergeRequestNotesNoteConnection.Nodes, and is useful for accessing the field via an interface.
func (v *GetNotesProjectMergeRequestNotesNoteConnection) GetNodes() []GetNotesProjectMergeRequestNotesNoteConnectionNodesNote {
	return v.Nodes
}

// GetNotesProjectMergeRequestNotesNoteConnectionNodesNote includes the requested fields of the GraphQL type Note.
type GetNotesProjectMergeRequestNotesNoteConnectionNodesNote struct {
	// ID of the note.
	Id string `json:"id"`
	// Discussion this note is a part of.
	Discussion GetNotesProjectMergeRequestNotesNoteConnectionNodesNoteDiscussion `json:"discussion"`
	// User who wrote this note.
	Author GetNotesProjectMergeRequestNotesNoteConnectionNodesNoteAuthorUserCore `json:"author"`
	// Indicates whether this note was created by the system or by a user.
	System bool `json:"system"`
	// Content of the note.
	Body string `json:"body"`
}

// GetId returns GetNotesProjectMergeRequestNotesNoteConnectionNodesNote.Id, and is useful for accessing the field via an interface.
func (v *GetNotesProjectMergeRequestNotesNoteConnectionNodesNote) GetId() string { return v.Id }

// GetDiscussion returns GetNotesProjectMergeRequestNotesNoteConnectionNodesNote.Discussion, and is useful for accessing the field via an interface.
func (v *GetNotesProjectMergeRequestNotesNoteConnectionNodesNote) GetDiscussion() GetNotesProjectMergeRequestNotesNoteConnectionNodesNoteDiscussion {
	return v.Discussion
}

// GetAuthor returns GetNotesProjectMergeRequestNotesNoteConnectionNodesNote.Author, and is useful for accessing the field via an interface.
func (v *GetNotesProjectMergeRequestNotesNoteConnectionNodesNote) GetAuthor() GetNotesProjectMergeRequestNotesNoteConnectionNodesNoteAuthorUserCore {
	return v.Author
}

// GetSystem returns GetNotesProjectMergeRequestNotesNoteConnectionNodesNote.System, and is useful for accessing the field via an interface.
func (v *GetNotesProjectMergeRequestNotesNoteConnectionNodesNote) GetSystem() bool { return v.System }

// GetBody returns GetNotesProjectMergeRequestNotesNoteConnectionNodesNote.Body, and is useful for accessing the field via an interface.
func (v *GetNotesProjectMergeRequestNotesNoteConnectionNodesNote) GetBody() string { return v.Body }

// GetNotesProjectMergeRequestNotesNoteConnectionNodesNoteAuthorUserCore includes the requested fields of the GraphQL type UserCore.
// The GraphQL type's documentation follows.
//
// Core represention of a GitLab user.
type GetNotesProjectMergeRequestNotesNoteConnectionNodesNoteAuthorUserCore struct {
	// Human-readable name of the user. Returns `****` if the user is a project bot
	// and the requester does not have permission to view the project.
	Name string `json:"name"`
	// Username of the user. Unique within this instance of GitLab.
	Username string `json:"username"`
}

// GetName returns GetNotesProjectMergeRequestNotesNoteConnectionNodesNoteAuthorUserCore.Name, and is useful for accessing the field via an interface.
func (v *GetNotesProjectMergeRequestNotesNoteConnectionNodesNoteAuthorUserCore) GetName() string {
	return v.Name
}

// GetUsername returns GetNotesProjectMergeRequestNotesNoteConnectionNodesNoteAuthorUserCore.Username, and is useful for accessing the field via an interface.
func (v *GetNotesProjectMergeRequestNotesNoteConnectionNodesNoteAuthorUserCore) GetUsername() string {
	return v.Username
}

// GetNotesProjectMergeRequestNotesNoteConnectionNodesNoteDiscussion includes the requested fields of the GraphQL type Discussion.
type GetNotesProjectMergeRequestNotesNoteConnectionNodesNoteDiscussion struct {
	// ID of this discussion.
	Id string `json:"id"`
}

// GetId returns GetNotesProjectMergeRequestNotesNoteConnectionNodesNoteDiscussion.Id, and is useful for accessing the field via an interface.
func (v *GetNotesProjectMergeRequestNotesNoteConnectionNodesNoteDiscussion) GetId() string {
	return v.Id
}

// GetNotesResponse is returned by GetNotes on success.
type GetNotesResponse struct {
	// Find a project.
	Project GetNotesProject `json:"project"`
}

// GetProject returns GetNotesResponse.Project, and is useful for accessing the field via an interface.
func (v *GetNotesResponse) GetProject() GetNotesProject { return v.Project }

type JobArtifactFileType string

const (
	// ACCESSIBILITY job artifact file type.
	JobArtifactFileTypeAccessibility JobArtifactFileType = "ACCESSIBILITY"
	// API FUZZING job artifact file type.
	JobArtifactFileTypeApiFuzzing JobArtifactFileType = "API_FUZZING"
	// ARCHIVE job artifact file type.
	JobArtifactFileTypeArchive JobArtifactFileType = "ARCHIVE"
	// BROWSER PERFORMANCE job artifact file type.
	JobArtifactFileTypeBrowserPerformance JobArtifactFileType = "BROWSER_PERFORMANCE"
	// CLUSTER APPLICATIONS job artifact file type.
	JobArtifactFileTypeClusterApplications JobArtifactFileType = "CLUSTER_APPLICATIONS"
	// CLUSTER IMAGE SCANNING job artifact file type.
	JobArtifactFileTypeClusterImageScanning JobArtifactFileType = "CLUSTER_IMAGE_SCANNING"
	// COBERTURA job artifact file type.
	JobArtifactFileTypeCobertura JobArtifactFileType = "COBERTURA"
	// CODE QUALITY job artifact file type.
	JobArtifactFileTypeCodequality JobArtifactFileType = "CODEQUALITY"
	// CONTAINER SCANNING job artifact file type.
	JobArtifactFileTypeContainerScanning JobArtifactFileType = "CONTAINER_SCANNING"
	// COVERAGE FUZZING job artifact file type.
	JobArtifactFileTypeCoverageFuzzing JobArtifactFileType = "COVERAGE_FUZZING"
	// CYCLONEDX job artifact file type.
	JobArtifactFileTypeCyclonedx JobArtifactFileType = "CYCLONEDX"
	// DAST job artifact file type.
	JobArtifactFileTypeDast JobArtifactFileType = "DAST"
	// DEPENDENCY SCANNING job artifact file type.
	JobArtifactFileTypeDependencyScanning JobArtifactFileType = "DEPENDENCY_SCANNING"
	// DOTENV job artifact file type.
	JobArtifactFileTypeDotenv JobArtifactFileType = "DOTENV"
	// JUNIT job artifact file type.
	JobArtifactFileTypeJunit JobArtifactFileType = "JUNIT"
	// LICENSE SCANNING job artifact file type.
	JobArtifactFileTypeLicenseScanning JobArtifactFileType = "LICENSE_SCANNING"
	// LOAD PERFORMANCE job artifact file type.
	JobArtifactFileTypeLoadPerformance JobArtifactFileType = "LOAD_PERFORMANCE"
	// LSIF job artifact file type.
	JobArtifactFileTypeLsif JobArtifactFileType = "LSIF"
	// METADATA job artifact file type.
	JobArtifactFileTypeMetadata JobArtifactFileType = "METADATA"
	// METRICS job artifact file type.
	JobArtifactFileTypeMetrics JobArtifactFileType = "METRICS"
	// METRICS REFEREE job artifact file type.
	JobArtifactFileTypeMetricsReferee JobArtifactFileType = "METRICS_REFEREE"
	// NETWORK REFEREE job artifact file type.
	JobArtifactFileTypeNetworkReferee JobArtifactFileType = "NETWORK_REFEREE"
	// PERFORMANCE job artifact file type.
	JobArtifactFileTypePerformance JobArtifactFileType = "PERFORMANCE"
	// REQUIREMENTS job artifact file type.
	JobArtifactFileTypeRequirements JobArtifactFileType = "REQUIREMENTS"
	// SAST job artifact file type.
	JobArtifactFileTypeSast JobArtifactFileType = "SAST"
	// SECRET DETECTION job artifact file type.
	JobArtifactFileTypeSecretDetection JobArtifactFileType = "SECRET_DETECTION"
	// TERRAFORM job artifact file type.
	JobArtifactFileTypeTerraform JobArtifactFileType = "TERRAFORM"
	// TRACE job artifact file type.
	JobArtifactFileTypeTrace JobArtifactFileType = "TRACE"
)

// State of a GitLab merge request
type MergeRequestState string

const (
	// All available.
	MergeRequestStateAll MergeRequestState = "all"
	// In closed state.
	MergeRequestStateClosed MergeRequestState = "closed"
	// Discussion has been locked.
	MergeRequestStateLocked MergeRequestState = "locked"
	// Merge request has been merged.
	MergeRequestStateMerged MergeRequestState = "merged"
	// In open state.
	MergeRequestStateOpened MergeRequestState = "opened"
)

// ReadFuzzProject includes the requested fields of the GraphQL type Project.
type ReadFuzzProject struct {
	// Build pipelines of the project.
	Pipelines ReadFuzzProjectPipelinesPipelineConnection `json:"pipelines"`
}

// GetPipelines returns ReadFuzzProject.Pipelines, and is useful for accessing the field via an interface.
func (v *ReadFuzzProject) GetPipelines() ReadFuzzProjectPipelinesPipelineConnection {
	return v.Pipelines
}

// ReadFuzzProjectPipelinesPipelineConnection includes the requested fields of the GraphQL type PipelineConnection.
// The GraphQL type's documentation follows.
//
// The connection type for Pipeline.
type ReadFuzzProjectPipelinesPipelineConnection struct {
	// A list of nodes.
	Nodes []ReadFuzzProjectPipelinesPipelineConnectionNodesPipeline `json:"nodes"`
}

// GetNodes returns ReadFuzzProjectPipelinesPipelineConnection.Nodes, and is useful for accessing the field via an interface.
func (v *ReadFuzzProjectPipelinesPipelineConnection) GetNodes() []ReadFuzzProjectPipelinesPipelineConnectionNodesPipeline {
	return v.Nodes
}

// ReadFuzzProjectPipelinesPipelineConnectionNodesPipeline includes the requested fields of the GraphQL type Pipeline.
type ReadFuzzProjectPipelinesPipelineConnectionNodesPipeline struct {
	// Jobs belonging to the pipeline.
	Jobs ReadFuzzProjectPipelinesPipelineConnectionNodesPipelineJobsCiJobConnection `json:"jobs"`
}

// GetJobs returns ReadFuzzProjectPipelinesPipelineConnectionNodesPipeline.Jobs, and is useful for accessing the field via an interface.
func (v *ReadFuzzProjectPipelinesPipelineConnectionNodesPipeline) GetJobs() ReadFuzzProjectPipelinesPipelineConnectionNodesPipelineJobsCiJobConnection {
	return v.Jobs
}

// ReadFuzzProjectPipelinesPipelineConnectionNodesPipelineJobsCiJobConnection includes the requested fields of the GraphQL type CiJobConnection.
// The GraphQL type's documentation follows.
//
// The connection type for CiJob.
type ReadFuzzProjectPipelinesPipelineConnectionNodesPipelineJobsCiJobConnection struct {
	// A list of nodes.
	Nodes []ReadFuzzProjectPipelinesPipelineConnectionNodesPipelineJobsCiJobConnectionNodesCiJob `json:"nodes"`
}

// GetNodes returns ReadFuzzProjectPipelinesPipelineConnectionNodesPipelineJobsCiJobConnection.Nodes, and is useful for accessing the field via an interface.
func (v *ReadFuzzProjectPipelinesPipelineConnectionNodesPipelineJobsCiJobConnection) GetNodes() []ReadFuzzProjectPipelinesPipelineConnectionNodesPipelineJobsCiJobConnectionNodesCiJob {
	return v.Nodes
}

// ReadFuzzProjectPipelinesPipelineConnectionNodesPipelineJobsCiJobConnectionNodesCiJob includes the requested fields of the GraphQL type CiJob.
type ReadFuzzProjectPipelinesPipelineConnectionNodesPipelineJobsCiJobConnectionNodesCiJob struct {
	// Name of the job.
	Name string `json:"name"`
	// Web path of the job.
	WebPath string `json:"webPath"`
	// Artifacts generated by the job.
	Artifacts ReadFuzzProjectPipelinesPipelineConnectionNodesPipelineJobsCiJobConnectionNodesCiJobArtifactsCiJobArtifactConnection `json:"artifacts"`
}

// GetName returns ReadFuzzProjectPipelinesPipelineConnectionNodesPipelineJobsCiJobConnectionNodesCiJob.Name, and is useful for accessing the field via an interface.
func (v *ReadFuzzProjectPipelinesPipelineConnectionNodesPipelineJobsCiJobConnectionNodesCiJob) GetName() string {
	return v.Name
}

// GetWebPath returns ReadFuzzProjectPipelinesPipelineConnectionNodesPipelineJobsCiJobConnectionNodesCiJob.WebPath, and is useful for accessing the field via an interface.
func (v *ReadFuzzProjectPipelinesPipelineConnectionNodesPipelineJobsCiJobConnectionNodesCiJob) GetWebPath() string {
	return v.WebPath
}

// GetArtifacts returns ReadFuzzProjectPipelinesPipelineConnectionNodesPipelineJobsCiJobConnectionNodesCiJob.Artifacts, and is useful for accessing the field via an interface.
func (v *ReadFuzzProjectPipelinesPipelineConnectionNodesPipelineJobsCiJobConnectionNodesCiJob) GetArtifacts() ReadFuzzProjectPipelinesPipelineConnectionNodesPipelineJobsCiJobConnectionNodesCiJobArtifactsCiJobArtifactConnection {
	return v.Artifacts
}

// ReadFuzzProjectPipelinesPipelineConnectionNodesPipelineJobsCiJobConnectionNodesCiJobArtifactsCiJobArtifactConnection includes the requested fields of the GraphQL type CiJobArtifactConnection.
// The GraphQL type's documentation follows.
//
// The connection type for CiJobArtifact.
type ReadFuzzProjectPipelinesPipelineConnectionNodesPipelineJobsCiJobConnectionNodesCiJobArtifactsCiJobArtifactConnection struct {
	// A list of nodes.
	Nodes []ReadFuzzProjectPipelinesPipelineConnectionNodesPipelineJobsCiJobConnectionNodesCiJobArtifactsCiJobArtifactConnectionNodesCiJobArtifact `json:"nodes"`
}

// GetNodes returns ReadFuzzProjectPipelinesPipelineConnectionNodesPipelineJobsCiJobConnectionNodesCiJobArtifactsCiJobArtifactConnection.Nodes, and is useful for accessing the field via an interface.
func (v *ReadFuzzProjectPipelinesPipelineConnectionNodesPipelineJobsCiJobConnectionNodesCiJobArtifactsCiJobArtifactConnection) GetNodes() []ReadFuzzProjectPipelinesPipelineConnectionNodesPipelineJobsCiJobConnectionNodesCiJobArtifactsCiJobArtifactConnectionNodesCiJobArtifact {
	return v.Nodes
}

// ReadFuzzProjectPipelinesPipelineConnectionNodesPipelineJobsCiJobConnectionNodesCiJobArtifactsCiJobArtifactConnectionNodesCiJobArtifact includes the requested fields of the GraphQL type CiJobArtifact.
type ReadFuzzProjectPipelinesPipelineConnectionNodesPipelineJobsCiJobConnectionNodesCiJobArtifactsCiJobArtifactConnectionNodesCiJobArtifact struct {
	// URL for downloading the artifact's file.
	DownloadPath string `json:"downloadPath"`
	// File type of the artifact.
	FileType JobArtifactFileType `json:"fileType"`
}

// GetDownloadPath returns ReadFuzzProjectPipelinesPipelineConnectionNodesPipelineJobsCiJobConnectionNodesCiJobArtifactsCiJobArtifactConnectionNodesCiJobArtifact.DownloadPath, and is useful for accessing the field via an interface.
func (v *ReadFuzzProjectPipelinesPipelineConnectionNodesPipelineJobsCiJobConnectionNodesCiJobArtifactsCiJobArtifactConnectionNodesCiJobArtifact) GetDownloadPath() string {
	return v.DownloadPath
}

// GetFileType returns ReadFuzzProjectPipelinesPipelineConnectionNodesPipelineJobsCiJobConnectionNodesCiJobArtifactsCiJobArtifactConnectionNodesCiJobArtifact.FileType, and is useful for accessing the field via an interface.
func (v *ReadFuzzProjectPipelinesPipelineConnectionNodesPipelineJobsCiJobConnectionNodesCiJobArtifactsCiJobArtifactConnectionNodesCiJobArtifact) GetFileType() JobArtifactFileType {
	return v.FileType
}

// ReadFuzzResponse is returned by ReadFuzz on success.
type ReadFuzzResponse struct {
	// Find a project.
	Project ReadFuzzProject `json:"project"`
}

// GetProject returns ReadFuzzResponse.Project, and is useful for accessing the field via an interface.
func (v *ReadFuzzResponse) GetProject() ReadFuzzProject { return v.Project }

// __GetNotesInput is used internally by genqlient
type __GetNotesInput struct {
	Project string `json:"project"`
	Mr      string `json:"mr"`
}

// GetProject returns __GetNotesInput.Project, and is useful for accessing the field via an interface.
func (v *__GetNotesInput) GetProject() string { return v.Project }

// GetMr returns __GetNotesInput.Mr, and is useful for accessing the field via an interface.
func (v *__GetNotesInput) GetMr() string { return v.Mr }

// __ReadFuzzInput is used internally by genqlient
type __ReadFuzzInput struct {
	Project string `json:"project"`
	Ref     string `json:"ref"`
	Last    int    `json:"last"`
}

// GetProject returns __ReadFuzzInput.Project, and is useful for accessing the field via an interface.
func (v *__ReadFuzzInput) GetProject() string { return v.Project }

// GetRef returns __ReadFuzzInput.Ref, and is useful for accessing the field via an interface.
func (v *__ReadFuzzInput) GetRef() string { return v.Ref }

// GetLast returns __ReadFuzzInput.Last, and is useful for accessing the field via an interface.
func (v *__ReadFuzzInput) GetLast() int { return v.Last }

func GetNotes(
	ctx context.Context,
	client graphql.Client,
	project string,
	mr string,
) (*GetNotesResponse, error) {
	req := &graphql.Request{
		OpName: "GetNotes",
		Query: `
query GetNotes ($project: ID!, $mr: String!) {
	project(fullPath: $project) {
		id
		mergeRequest(iid: $mr) {
			draft
			title
			description
			state
			targetBranch
			assignees {
				nodes {
					id
					username
				}
			}
			labels {
				nodes {
					title
				}
			}
			approvedBy {
				nodes {
					username
				}
			}
			author {
				username
			}
			notes {
				nodes {
					id
					discussion {
						id
					}
					author {
						name
						username
					}
					system
					body
				}
			}
		}
	}
}
`,
		Variables: &__GetNotesInput{
			Project: project,
			Mr:      mr,
		},
	}
	var err error

	var data GetNotesResponse
	resp := &graphql.Response{Data: &data}

	err = client.MakeRequest(
		ctx,
		req,
		resp,
	)

	return &data, err
}

func ReadFuzz(
	ctx context.Context,
	client graphql.Client,
	project string,
	ref string,
	last int,
) (*ReadFuzzResponse, error) {
	req := &graphql.Request{
		OpName: "ReadFuzz",
		Query: `
query ReadFuzz ($project: ID!, $ref: String, $last: Int) {
	project(fullPath: $project) {
		pipelines(ref: $ref, source: "schedule", first: $last, status: SUCCESS) {
			nodes {
				jobs {
					nodes {
						name
						webPath
						artifacts {
							nodes {
								downloadPath
								fileType
							}
						}
					}
				}
			}
		}
	}
}
`,
		Variables: &__ReadFuzzInput{
			Project: project,
			Ref:     ref,
			Last:    last,
		},
	}
	var err error

	var data ReadFuzzResponse
	resp := &graphql.Response{Data: &data}

	err = client.MakeRequest(
		ctx,
		req,
		resp,
	)

	return &data, err
}
